#! /usr/bin/env python3 -B

from testlib import check, runtests
import json

import program

def test_program_1a():
    '''\nPrimo test della funzione es1 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C3'\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},{'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1': 8, 'C2': 3 ,'C3': 'c'} ]
    expected= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 8, 'C2': 3 ,'C3': 'c'},{'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1': 4, 'C2': 7 ,'C3': 'a'}]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es1(tabella1,'C3')
    check(returned,3,None,explanation1)
    explanation2 = "la tabella  non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1
    
def test_program_1b():
    '''\nSecondo test della funzione es1 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C1'\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},{'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1': 8, 'C2': 3 ,'C3': 'c'} ]
    expected= [{'C1': 8, 'C2': 3 ,'C3': 'c'},{'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1': 4, 'C2': 7 ,'C3': 'a'},{'C1': 2, 'C2': 1 ,'C3': 'd'}]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es1(tabella1,'C1')
    check(returned,3,None,explanation1)
    explanation2 = "la tabella  non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1


def test_program_2a():
    '''\nPrimo test della funzione es2 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C2' e valore=1\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    expected= [{'C1': 2, 'C3': 'd'},{'C1': 6,'C3': 'b'} ]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es2(tabella1,'C2',1)
    check(returned,2,None,explanation1)
    explanation2 = "la tabella non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1
    
def test_program_2b():
    '''\nSecondo test della funzione es2 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C1' e valore=3\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    expected= []
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es2(tabella1,'C1',3)
    check(returned,4,None,explanation1)
    explanation2 = "la tabella non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1

    
def test_program_3a():
    '''\nPrimo test della funzione es3 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C2' e valore=1\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    tabella2= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    expected= [{'C1': 2, 'C3': 'd'},{'C1': 6,'C3': 'b'} ]
    explanation1 = "la tabella restituita non e' corretta"
    returned    = program.es3(tabella1,'C2',1)
    check(returned,expected,None,explanation1)
    explanation2 = "la tabella originale  e' stata modificata"
    check(tabella1, tabella2, None, explanation2 )
    return 1
    
def test_program_3b():
    '''\nSecondo test della funzione es3 con tabella1=
    [{'C1': 2, 'C2': 1 ,'C3': 'd'},
     {'C1': 4, 'C2': 7 ,'C3': 'a'},
     {'C1': 6, 'C2': 1 ,'C3': 'b'},
     {'C1': 8, 'C2': 3 ,'C3': 'c'}
    ] e colonna='C1' e valore=8\n'''
    tabella1= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    tabella2= [{'C1': 2, 'C2': 1 ,'C3': 'd'},{'C1': 4, 'C2': 7 ,'C3': 'a'},\
    {'C1': 6, 'C2': 1 ,'C3': 'b'},{'C1':8, 'C2': 3 ,'C3': 'c'} ]
    expected= [{'C2': 3 ,'C3': 'c'} ]
    explanation1 = "la tabella restituita non e' corretta"
    returned    = program.es3(tabella1,'C1',8)
    check(returned,expected,None,explanation1)
    explanation2 = "la tabella originale  e' stata modificata"
    check(tabella1, tabella2, None, explanation2 )
    return 1
    
    
def test_program_4a():
    '''\nPrimo test della funzione es4 con
-tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 3, 'C2': 'a' ,},{'C1': 4, 'C2': 'a' },{'C1': 5, 'C2': 'a' },{'C1': 7, 'C2': 'b' }],
-tabella2=[{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2': 'b' ,},{'C1': 5, 'C2': 'a' },{'C1': 6, 'C2': 'b' },{'C1': 7, 'C2': 'a' }] 
-colonna='C1'\n'''
    tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 3, 'C2': 'a'},{'C1': 4, 'C2':'a'},{'C1': 5, 'C2': 'a'},{'C1': 7, 'C2': 'b'}]
    tabella2=[{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2': 'b'},{'C1': 5, 'C2':'a'},{'C1': 6, 'C2': 'b'},{'C1': 7, 'C2': 'a'}] 
    expected=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'}, {'C1': 3,'C2':'a'},{'C1': 4, 'C2': 'a'},{'C1': 5, 'C2': 'a'},{'C1': 6, 'C2': 'b'}, {'C1': 7, 'C2':'b'}]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es4(tabella1,tabella2,'C1')
    check(returned,2,None,explanation1)
    explanation2 = "la tabella non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1
     
def test_program_4b():
    '''\nSecondo test della funzione es4 con
-tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a' ,},{'C1': 3, 'C2': 'a' }],
-tabella2=[{'C1': 3, 'C2': 'a'},{'C1': 4, 'C2': 'b' ,},{'C1': 5, 'C2': 'a' }] 
-colonna='C1'\n'''
    tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2':'a'}]
    tabella2=[{'C1': 3, 'C2': 'b'},{'C1': 4, 'C2': 'b'},{'C1': 5, 'C2':'a'}] 
    expected=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'}, {'C1': 3,'C2':'a'},{'C1': 4, 'C2': 'b'}, {'C1': 5, 'C2':'a'}]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es4(tabella1,tabella2,'C1')
    check(returned,2,None,explanation1)
    explanation2 = "la tabella non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 1

def test_program_4c():
    '''\nSecondo test della funzione es4 con
-tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a' ,},{'C1': 3, 'C2': 'a' }],
-tabella2=[{'C1': 3, 'C2': 'a'},{'C1': 4, 'C2': 'b' ,},{'C1': 5, 'C2': 'a' }] 
-colonna='C1'\n'''
    tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2':'a'}]
    tabella2=[{'C1': 1, 'C2': 'y'},{'C1': 2, 'C2': 'z'},{'C1': 3, 'C2':'t'}] 
    expected=[{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2':'a'}]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es4(tabella1,tabella2,'C1')
    check(returned,0,None,explanation1)
    explanation2 = "la tabella non e' stata modificata correttamente"
    check(tabella1, expected, None, explanation2 )
    return 2
    
def test_program_5a():
    "\nPrimo test della funzione es5 usando  fname1='ftesto1.txt', fname2='ftesto1b.txt' e ftesto3='risposta1.txt'"
    expected= 'tutt?      a    n?nna?'
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es5('ftesto1.txt','ftesto1b.txt','risposta1.txt')
    check(returned,2,None,explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('risposta1.txt','r', encoding='utf8') as f:
        testo=f.read()
    check(testo, expected, None, explanation2 )
    return 2

def test_program_5b():
    "\nSecondo test della funzione es5 usando  fname1='ftesto2.txt', fname2='ftesto2b.txt' e ftesto3='risposta2.txt'"
    expected= '?hi stu?ia passa!'
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es5('ftesto2.txt','ftesto2b.txt','risposta2.txt')
    check(returned,2,None,explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('risposta2.txt','r', encoding='utf8') as f: testo=f.read()
    check(testo, expected, None, explanation2 )
    return 2

def test_program_6a():
    "\nPrimo test della funzione es6 usando  fname1='ftesto3.txt',  e ftesto2='risposta3.txt'"
    expected= 'MoNtI, SterBINI e SPoGNArDI'
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es6('ftesto3.txt','risposta3.txt')
    check(returned,7,None,explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('risposta3.txt','r', encoding='utf8') as f: testo=f.read()
    check(testo, expected, None, explanation2 )
    return 2
    
def test_program_6b():
    "\nSecondo test della funzione es6 usando  fname1='ftesto4.txt',  e ftesto2='risposta4.txt'"
    expected= '''SalvE, Ho Una doManda:
Ma lo zERo E' Un nUMERo paRi o diSpaRi?
So cHE pUo' SEMbRaRE Una banaliTa', a naSo diREi cHE lo zERo E' Un nUMERo paRi
Ma non SapREi coME GiUSTificaRE la RiSpoSTa.
Confido nEl voSTRo aiUTo!'''
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es6('ftesto4.txt','risposta4.txt')
    check(returned,8,None,explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('risposta4.txt','r', encoding='utf8') as f: testo=f.read()
    check(testo, expected, None, explanation2 )
    return 2
    
def test_program_7a():
    "\nPrimo test della funzione es7 usando  fname1='file1.json''"
    expected= [(2, 0), (0, 6), (4, 4), (1, 0), (7, 16)]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es7('file1.json')
    check(returned,expected,None,explanation1)
    return 2
    
def test_program_7b():
    "\nSecondo test della funzione es7 usando  fname1='file2.json''"
    expected= [(6, 8), (15, 0), (0, 0), (0, 10), (25, 20)]
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es7('file2.json')
    check(returned,expected,None,explanation1)
    return 2
    
def test_program_8a():
    "\nPrimo test della funzione es8 usando  fname1='ftesto3.txt',  e ftesto2='istogramma1.txt'"
    expected= 'iiii\nnnn\nee\noo\nrr\ntt\na\nb\nd\ng\np'
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es8('ftesto3.txt','istogramma1.txt')
    check(returned,11,None,explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('istogramma1.txt','r', encoding='utf8') as f: testo=f.read()
    check(testo, expected, None, explanation2 )
    return 3
    
def test_program_8b():
    "\nSecondo test della funzione es8 usando  fname1='ftesto4.txt',  e ftesto2='istogramma2.txt'"
    expected= 'aaaaaaaaaaaaaaaaaaaaa\noooooooooooooooooooo\neeeeeeeeeeeeeeee\niiiiiiiiiiiiii\nrrrrrrrrrrrrrr\n'+\
    'nnnnnnnnnnnnn\nuuuuuuuuu\nssssssss\nmmmmmmm\nllllll\npppppp\nddddd\nttttt\ncccc\nhhh\nbb\nff\nvv\nzz\ng'
    explanation1 = "il valore restituito non e' corretto"
    returned    = program.es8('ftesto4.txt','istogramma2.txt')
    check(returned, 20, None, explanation1)
    explanation2 = "il file generato non e' corretto"
    with open('istogramma2.txt','r', encoding='utf8') as f: testo=f.read()
    check(testo, expected, None, explanation2 )
    return 3

def test_program_9a():
    "\nPrimo test della funzione es9 usando  fname1='file3.json' e fname2='risposta5.json' "
    expected= [['X', '1', '?'], ['?', 'X', '1'], ['1', '?', 'X']]
    explanation1 = "il valore restituito non e' corretto"
    explanation2 = "il file json generato non e' corretto"
    returned    = program.es9('file3.json','risposta5.json')
    check(returned,{'X','1','?'},None,explanation1)
    with open('risposta5.json', encoding='utf8') as f: scacchiera = json.load(f)
    check(scacchiera,expected,None,explanation2)
    return 3
    
def test_program_9b():
    "\nSecondo test della funzione es9 usando  fname1='file4.json' e fname2='risposta6.json' "
    expected= [['a','b','!','1','='],['1','a','=','!','b'],['!','1','b','=','a'],['=','!','a','b','1'],['b','=','1','a','!']]
    explanation1 = "il valore restituito non e' corretto"
    explanation2 = "il file json generato non e' corretto"
    returned    = program.es9('file4.json','risposta6.json')
    check(returned,{'a','b','!','1','='},None,explanation1)
    with open('risposta6.json', encoding='utf8') as f: scacchiera = json.load(f)
    check(scacchiera,expected,None,explanation2)
    return 3


#********************************************
    

tests = [
        test_program_1a, test_program_1b,
        test_program_2a, test_program_2b,
        test_program_3a, test_program_3b,
        test_program_4a, test_program_4b,test_program_4c,
        test_program_5a, test_program_5b,
        test_program_6a, test_program_6b,
        test_program_7a, test_program_7b,
        test_program_8a, test_program_8b,
        test_program_9a, test_program_9b,
        ]


if __name__ == '__main__':
    #runtests(tests)
    runtests(tests,logfile='grade.csv')

