'''
Progettate una o piu' delle seguenti funzioni 
(all'inizio di ogni funzione viene specificato il numero di punti assegnato dal grader a quella funzione)
Il punteggio complessivo dato dal grader e' il voto della prova di recupero.
Se la somma dei punteggi ottenuti con gli esercizi e' maggiore di 32, si otterra' il punteggio 32.

NOTA: il grader testa tutte le funzioni, quindi stampera' degli errori per le funzioni non implementate
'''
###############################################################################################

''' 
    Un modo comune di memorizzare tabelle e' come liste di dizionari. 
    Ogni riga della tabella corrisponde ad un dizionario le cui chiavi sono i nomi delle colonne della tabella.
    Questa collezione di dizionari e' poi memorizzata in una lista.
    Ad esempio la tabella
    
    nome  | anno | tel
  --------|------|---------
   Sofia  | 1973 | 5553546 
   Bruno  | 1981 | 5558432

puo' essere memorizzata come 
[{'nome': 'Sofia', 'anno': 1973 ,'tel': 5553546},{'nome': 'Bruno', 'anno': 1981 ,'tel': 5558432}]

'''


###############################################################################################

def es1(tabella, colonna):
    ''' 
    1) 2 punti
    Si implementi la funzione es1(tabella,colonna) che presi in input
    - una tabella rappresentata tramite lista di dizionari
    - una stringa con il nome di una delle colonne della tabella
    modifica distruttivamente la tabella riordinandone le righe in ordine decrescente rispetto 
    ai valori contenuti nella  colonna indicata. La funzione deve restituire il numero di colonne della tabella.
        Ad esempio con  tabella = [{'nome': 'Bruno', 'anno': 1981 ,'tel': 5558432},{'nome': 'Sofia', 'anno': 1973 ,'tel': 5553546}]
    al termine di es1(dati, 'anno')  la  tabella sara' stata modificata in 
    [{'nome': 'Bruno', 'anno': 1981 ,'tel': 5558432},{'nome': 'Sofia', 'anno': 1973 ,'tel': 5553546}]
    e restituisce il numero di colonne 3.
    '''
    # inserisci qui il tuo codice
    tabella.sort(key= lambda x: x[colonna],reverse=True)
    return len(tabella[0])

###############################################################################################

def es2(tabella, colonna, valore):
    ''' 
    1) 2 punti
    Si implementi la funzione es2(tabella, colonna, valore) che presi in input
    - una tabella rappresentata tramite lista di dizionari
    - una stringa con il nome di una delle colonne della tabella
    - un valore
    modifica distruttivamente la tabella eliminando  la colonna indicata e 
    le righe che in quella colonna avevano valori diversi da valore.
    La funzione deve poi restituire il numero di righe eliminate.
    Ad esempio con  tabella = [{'nome': 'Sofia', 'anno': 1973 ,'tel': 5553546},{'nome': 'Bruno', 'anno': 1981 ,'tel': 5558432}]
    al termine di es2(dati, 'anno', 1981)  verra' restituito il numero 1 e la tabella 
    risultera'  modificata  in [{'nome': 'Bruno','tel': 5558432}]

    '''
    # inserisci qui il tuo codice
    canc=0
    for i in range(len(tabella)-1,-1,-1):
        if tabella[i][colonna]!=valore:
            del tabella[i]
            canc+=1
        else: 
            del tabella[i][colonna]
    return canc
  

###############################################################################################

def es3(tabella,colonna,valore):
    ''' 
    1) 2 punti
    Si implementi la funzione es3(tabella, colonna, valore) che presi in input
    - una tabella rappresentata tramite lista di dizionari
    - una stringa con il nome di una delle colonne della tabella
    - un valore
    restituisce la  sottotabella che si ottiene eliminando dalla tabella la colonna indicata e
    le righe che in quella colonna avevano valori diversi da valore.
    La tabella originaria non deve essere modificata e nella nuova tabella le righe devono conservare il vecchio ordinamento.
    Ad esempio con  tabella = [{'nome': 'Sofia', 'anno': 1973 ,'tel': 5553546},{'nome': 'Bruno', 'anno': 1981 ,'tel': 5558432}]
    al termine di es3(dati, 'anno', 1981) verra' restituita la tabella
    [{'nome': 'Bruno','tel': 5558432}]
    '''
    # inserisci qui il tuo codice
    tabella1=[]
    for riga in tabella:
        if riga[colonna]==valore:
            riga1={}
            for x in riga:
                riga1[x]=riga[x]
            del riga1[colonna]
            tabella1+=[riga1]
    return tabella1

###############################################################################################

def es4(tabella1,tabella2,col):
    ''' 
    1) 4 punti
    Si implementi la funzione es4(tabella1, tabella2, col) che prese in input
    - due tabelle: tabella1 e tabella2,  rappresentate tramite lista di dizionari ed aventi le stesse colonne
    - una stringa con il nome di una delle colonne delle due tabelle rispetto alla quale le due tabelle sono ordinate in modo crescente.
    modifica distruttivamente la tabella 1.
    Le righe della tabella 1 differiscono tutte nella colonna col  e lo stesso vale per le righe della tabella 2.
    Bisogna inserire nella tabella 1 righe della tabella 2. 
    Una riga della tabella 2 deve essere  inserita nella tabella 1 solo se nella sua colonna  col contiene un valore
    non presente tra quelli che compaiono nella corrispondente colonna della tabella1. 
    Al termine la tabella 1 deve ancora risultare ordinata rispetto ai valori della colonna col.  
    La funzione deve restituire il numero delle righe inserite nella tabella1.  
    Ad esempio con: 
    tabella1=[{'C1': 1, 'C2': 'x'},{'C1': 3, 'C2': 'a'},{'C1': 4, 'C2': 'a' },{'C1': 5, 'C2': 'a' },{'C1': 7, 'C2': 'b' }],
    tabella2=[{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2': 'b'},{'C1': 5, 'C2': 'a' },{'C1': 6, 'C2': 'b' },{'C1': 7, 'C2': 'a' }] 
    al termine di es4(tabella1, tabella2, 'C1') verra' restituito il numero 2 e la tabella1 risultera'
    [{'C1': 1, 'C2': 'x'},{'C1': 2, 'C2': 'a'},{'C1': 3, 'C2': 'a' ,},{'C1': 4, 'C2': 'a' },{'C1': 5, 'C2': 'a' },\
    {'C1': 6, 'C2': 'b' },{'C1': 7, 'C2': 'b' }]
    '''
    # inserisci qui il tuo codice
    i=j=tot=0
    tabella=[]
    while i<len(tabella1) and j<len(tabella2):
        if tabella1[i][col]==tabella2[j][col]:
            j+=1
        elif tabella1[i][col]>tabella2[j][col]:
            d=tabella2[j]
            tabella+=[d]
            j+=1
            tot+=1
        else: 
            tabella+=[tabella1[i]]
            i+=1
    while i<len(tabella1):  
        tabella+= [tabella1[i]]
        i+=1 
    while j<len(tabella2):  
        tabella+= [tabella2[j]]
        j+=1 
        tot+=1
    tabella1[:]=tabella
    return tot
    
  
    
###############################################################################################

def es5(fname1,fname2,fname3):
    ''' 
    1) 2 punti
    Si implementi la funzione es5(fname1,fname2,fname3) prende in input l'indirizzo di tre file di testo.
    Il primo file di testo contiene un messaggio codificato dove ogni carattere e' stato 
    sostituito da un intero di tre cifre.
    Tutti i caratteri non numerici devono essere trasferiti come sono.
    Nel secondo file  e' possibile ritrovare le corrispondenze numeri-caratteri tra i numeri 
    del testo e il rispettivo carattere. 
    Piu' precisamente questo secondo file e' organizzato in righe,  in ciascuna riga sono 
    presenti un carattere  e un intero  di tre cifre  che gli corrisponde nel file di testo separati da almeno uno spazio.
    Numeri diversi possono far riferimento ad uno stesso carattere e non tutti i numeri che appaiono in fname1
    sono necessariamente presenti nel file di decodifica.
    La funzione es5 deve decodificare il messaggio presente nel primo file grazie 
    alle informazioni contenute nel secondo.
    I numeri non presenti nel secondo file vanno decodificati con il simbolo '?'.
    Il messaggio decodificato va poi salvato nel terzo file.
    La funzione infine restituisce il numero di caratteri decodificati con il valore '?' presenti nel file decodificato.
    Ad esempio se 
    - il file fname1 contiene il testo '991118991991345      103    091027003091103?'
    - il file fname2 contiene il testo 'n   091\n   t 991\n a   103\n a 127\n n 003\n  u 118 '
    il testo decodificato da registrare in file3 sara': 'tutt? a n?nna?' e la funzione restituisce il numero 2.
    Potete assumere che i caratteri numerici appaiano sempre raggruppati in triplette.
    '''
    # inserisci qui il tuo codice
    d={}
    with open(fname2, encoding='utf8') as f:
        for line in f:
            riga=line.split()
            d[riga[1]]=riga[0]
    with open(fname1) as f:
        testo=f.read()
    testo1=''
    i=count=0
    while i< len(testo):
        if testo[i] not in '0123456789':
            testo1+=testo[i]
            i+=1
        else:
            num=testo[i:i+3]
            if num in d:
                testo1+=d[num]
            else:
                testo1+='?'
                count+=1
            i+=3
    with open(fname3,'w', encoding='utf8') as f:
        f.write(testo1)
    return count
    
###############################################################################################
    
def es6(fname1,fname2):
    ''' 
    1) 4 punti
    Implementate la funzione es6(fname1,fname2) che prende in input l'indirizzo di due  file di testo.
    Il testo del primo file va modificato come segue:
    - ciascun carattere tra 'a' e 'z' (minuscoli) che compare nel file in un numero dispari di parole
    (una parola e' una sequenza massimale di caratteri diversi dallo spazio, tab o a capo)
    va sostituito dal corrispondente carattere maiuscolo.
    Il file cosi' ottenuto va poi registrato all'indirizzo fname2.
    La funzione deve restituire quanti dei 26 caratteri tra 'a' e 'z' 
    da minuscoli son diventati maiuscoli nella trasformazione del file di testo. 
    Ad esempio se 
    - il file fname1 contiene  il testo 'Monti, Sterbini e Spognardi'
    - il file fname2 conterra' il testo 'MoNtI, SterBINI e SPoGNArDI'
    il valore restituito dalla funzione sara' 7 (le lettere cambiate sono NIBPGAD)
    '''
    # inserisci qui il tuo codice
    with open(fname1, encoding='utf8') as f:
        testo=f.read()
    lista=testo.split()
    d={}
    for parola in lista:
        caratteri=set(parola)
        for c in caratteri:
            if c in d: d[c]+=1
            else: d[c]=1
    testo1=''
    for c in testo:
        if 'a'<=c<='z' and d[c]%2: 
            testo1+=c.upper()
        else: testo1+=c
    with open(fname2, 'w', encoding='utf8') as f:
        f.write(testo1)
    tot=0
    for c in d:
        if 'a'<=c<='z' and d[c]%2:
            tot+=1
    return tot
    
 ###############################################################################################

import json
    
def es7(fname1):
    ''' 
    1) 4 punti
    Si implementi la funzione es7(fname1) prende in input l'indirizzo di un file json e restituisce una lista di interi.
    Il file json contiene una lista di stringhe e ogni stringa e' composta da cifre decimali.
    La lista restituita ha lo stesso numero di elementi della lista originaria ma ciascuna stringa 
    risulta sostituita dalla tupla di due interi A,B. Al primo posto della tupla c'e' l'intero A che si ottimene
    sommando le cifre dispari della stringa, al secondo posto l'intero B che si
    ottiene sommando le cifre pari della lista.
    Ad esempio:
    la lista restituita da es7(fname1) con fname1 contenente la lista ['11','24','134','1','2876']
    sara' [(2,0), (0,6), (4,4), (1,0), (7,16)]'''
    # inserisci qui il tuo codice
    with open(fname1, encoding='utf8') as f:
        lista = json.load(f)
    lista1=[]
    for stringa in lista:
        numero1=0
        numero2=0
        for c in stringa: 
            if c in "13579":
                numero1+=int(c)
            else:
                numero2+=int(c)
        lista1+=[(numero1,numero2)]
    return lista1

 ###############################################################################################
def es8(fname1,fname2):
    ''' 
    1) 6 punti
    Implementate la funzione es8(fname1,fname2) prende in input l'indirizzo di un  file di testo fname e
    costruisce un istogramma con le frequenze di alcuni dei caratteri presenti nel  file di testo. 
    Salva l'istogramma creato nel file di testo fname2 e restituisce il numero di linee di cui e' composto.
    L'istogramma contiene tante linee quanti sono i caratteri tra 'a' e 'z' presenti nel testo.
    Se un certo carattere x compare nel testo  y volte allora nell'istogramma ci sara' 
    una riga con una stringa composta dal carattere x ripetuto y volte. Le righe dell'istogramma 
    vanno ordinate per lunghezza decrescente dei caratteri che vi compaiono e 
    lessicograficamente a parita' di lunghezza.
    Ad esempio se il file fname1 contiene il testo 'Monti, Sterbini e Spognardi' allora
    il valore restituito dalla funzione sara' 8 e  l'istogramma sara'
    iiii
	nnn
	ee
	oo
	rr
	tt
	a
	b
	d
	g
	p
    '''
    # inserisci qui il tuo codice
    with open(fname1, encoding='utf8') as f:
        testo = f.read()
    d={}
    for c in testo:
        if 'a'<= c <='z':
            if c in d: d[c]+=1
            else: d[c]=1
    lista=list(d.items())
    lista.sort()
    lista.sort(key=lambda x: x[1],reverse=True)
    testo=''
    for x in lista:
        testo+=x[0]*x[1]
        testo+= '\n'
    a=len(d)
    if a: testo=testo[:-1]
    with open(fname2, 'w', encoding='utf8') as f:
        testo = f.write(testo)
    return a
    
 ###############################################################################################

def es9(fname1,fname2):
    ''' 
    1) 6 punti  
    Un quadrato latino e' una scacchiera quadrata di lato N con un simbolo (scelto in un insieme di N elementi)
    su ogni casella in modo che ognuno dei simboli compaia una e una sola volta in ogni riga e in ogni colonna.
    Implementate la funzione es9(fname1,fname2) che prende in input l'indirizzo fname1 di un file json in cui e'
    contenuto un quadrato latino privato dell'ultima riga e dell'ultima colonna. 
    La scacchiera e' rappresentata come lista di liste. Bisogna completare il quadrato latino e 
    registrarlo come file json all'indirizzo fname2. 
    La funzione deve poi restituire l'insieme dei simboli che compaiono nel quadrato latino.
    Ad esempio: se la lista di liste in fname1 con il quadrato latino parziale e'
    [['X','1'],['?','X']] allora, l'insieme  con i simboli del quadrato latino sara' 
    {'X','1','?'} e la lista di liste in fname2 con il quadrato latino completo sara' 
    [['X','1','?'],['?','X','1'],['1','?','X']]
    Nota: assumete che sia sempre N>2
    ''' 
    # inserisci qui il tuo codice
    with open(fname1, encoding='utf8') as f:
        scacchiera = json.load(f)
    simboli=set(scacchiera[0]) | set (scacchiera[1])
    for riga in scacchiera:
        c=simboli-set(riga)
        riga += [c.pop()]
    riga1=[]
    for i in range(len(scacchiera[0])):
        colonna=set()
        for j in range(len(scacchiera)):
            colonna.add(scacchiera[j][i])
        c= simboli - colonna
        riga1+=[c.pop()]
    scacchiera+=[riga1]
    with open(fname2, 'w', encoding='utf8') as f:
        json.dump(scacchiera,f)
    return simboli
    
###############################################################################################
